if select(6, GetAddOnInfo("PitBull_" .. (debugstack():match("[i%.][t%.][B%.]ull\\Modules\\(.-)\\") or debugstack():match("[i%.][t%.][B%.]ull\\(.-)\\") or ""))) ~= "MISSING" then return end

local VERSION = tonumber(("$Revision: 39962 $"):match("%d+"))

local PitBull = PitBull
local PitBull_RaidTargetIcon = PitBull:NewModule("RaidTargetIcon", "AceEvent-2.0")
local self = PitBull_RaidTargetIcon
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-06-14 21:09:38 -0400 (Thu, 14 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end
self.desc = "Show an icon on the unit frame based on which Raid Target it is."

local L = PitBull:L("PitBull-RaidTargetIcon")

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame

PitBull_RaidTargetIcon:RegisterPitBullChildFrames('raidTargetIcon')

function PitBull_RaidTargetIcon:OnInitialize()
	self.db = PitBull:AcquireDBNamespace("RaidTargetIcon")
	PitBull:RegisterDefaults("RaidTargetIcon", "profile", {
		['*'] = {
			disable = false,
		}
	})
end

function PitBull_RaidTargetIcon:OnEnable()
	self:RegisterEvent("RAID_TARGET_UPDATE")
	self:RegisterEvent("RAID_ROSTER_UPDATE", "RAID_TARGET_UPDATE")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED", "RAID_TARGET_UPDATE")
end

function PitBull_RaidTargetIcon:Update(unit, frame)
	local index = GetRaidTargetIndex(unit)
	if not frame.group then
		AceLibrary("AceConsole-2.0"):Print("Error in PitBull_RaidTargetIcon, please report this to ckknight:", debugstack())
		return
	end
	if self.db.profile[frame.group].disable then
		index = nil
	end
	if index then
		if not frame.raidTargetIcon then
			frame.raidTargetIcon = newFrame("Texture", frame.overlay, "ARTWORK")
			frame.raidTargetIcon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
			PitBull:UpdateLayout(frame)
		end
		
		SetRaidTargetIconTexture(frame.raidTargetIcon, index)
	else
		if frame.raidTargetIcon then
			frame.raidTargetIcon = delFrame(frame.raidTargetIcon)
			
			PitBull:UpdateLayout(frame)
		end
	end
end

function PitBull_RaidTargetIcon:RAID_TARGET_UPDATE()
	for unit, frame in PitBull:IterateNonWackyUnitFrames() do
		self:Update(unit, frame)
	end
end

function PitBull_RaidTargetIcon:OnUpdateFrame(unit, frame)
	self:Update(unit, frame)
end

function PitBull_RaidTargetIcon:OnClearUnitFrame(unit, frame)
	if frame.raidTargetIcon then
		frame.raidTargetIcon = delFrame(frame.raidTargetIcon)
	end
end

function PitBull_RaidTargetIcon:OnUnknownLayout(unit, frame)
	frame.raidTargetIcon:SetPoint("CENTER", frame, "TOP", 0, -3)
	frame.raidTargetIcon:SetWidth(18)
	frame.raidTargetIcon:SetHeight(18)
end

local function getEnable(group)
	return not PitBull_RaidTargetIcon.db.profile[group].disable
end
local function setEnable(group, value)
	PitBull_RaidTargetIcon.db.profile[group].disable = not value
	
	for unit, frame in PitBull:IterateUnitFramesByGroup(group) do
		PitBull_RaidTargetIcon:Update(unit, frame)
	end
end
PitBull_RaidTargetIcon:RegisterPitBullOptionsMethod(function(group)
	return {
		type = "toggle",
		name = L["Enable raid target icon"],
		desc = L["Enable raid target icon display on the unit frames for this unit type."],
		get = getEnable,
		set = setEnable,
		passValue = group,
	}
end)
